<?php

declare (strict_types=1);
namespace GuardDog\Vendor\CBOR\Tag;

use GuardDog\Vendor\CBOR\ByteStringObject;
use GuardDog\Vendor\CBOR\CBORObject;
use GuardDog\Vendor\CBOR\IndefiniteLengthByteStringObject;
use GuardDog\Vendor\CBOR\Normalizable;
use GuardDog\Vendor\CBOR\Tag;
use GuardDog\Vendor\CBOR\Utils;
use InvalidArgumentException;
final class UnsignedBigIntegerTag extends Tag implements Normalizable
{
    public function __construct(int $additionalInformation, ?string $data, CBORObject $object)
    {
        if (!$object instanceof ByteStringObject && !$object instanceof IndefiniteLengthByteStringObject) {
            throw new InvalidArgumentException('This tag only accepts a Byte String object.');
        }
        parent::__construct($additionalInformation, $data, $object);
    }
    public static function getTagId(): int
    {
        return self::TAG_UNSIGNED_BIG_NUM;
    }
    public static function createFromLoadedData(int $additionalInformation, ?string $data, CBORObject $object): Tag
    {
        return new self($additionalInformation, $data, $object);
    }
    public static function create(CBORObject $object): Tag
    {
        [$ai, $data] = self::determineComponents(self::TAG_UNSIGNED_BIG_NUM);
        return new self($ai, $data, $object);
    }
    public function normalize(): string
    {
        /** @var ByteStringObject|IndefiniteLengthByteStringObject $object */
        $object = $this->object;
        return Utils::hexToString($object->normalize());
    }
}
